//Compile with /J
#pragma warning(disable:4265 4710)
#pragma warning(once:4339)
#using <System.dll>
#using <System.Drawing.dll>
#using <System.Windows.Forms.dll>
#include <ATcrt/ATsystem.h>
#define _WIN32_WINNT 0x0501
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>

[assembly:System::CLSCompliantAttribute(true)];	//Generates a warning if I am using something not CLS compliant

#ifndef _WIN64
	#using "..\output\Win-x86\Globales.dll"
	#using "..\output\Win-x86\ControlesAt.dll"
	#using "..\output\Win-x86\Basicas.dll"
#else
	#using "..\output\Win-amd64\Globales.dll"
	#using "..\output\Win-amd64\ControlesAt.dll"
	#using "..\output\Win-amd64\Basicas.dll"
#endif

#include <cstdlib>
#include <process.h>
//#include <shlobj.h>
typedef enum {
    SHGFP_TYPE_CURRENT  = 0,   // current value for user, verify it exists
    SHGFP_TYPE_DEFAULT  = 1,   // default value, may not exist
} SHGFP_TYPE;
STDAPI SHGetFolderPathW(__reserved HWND hwnd, __in int csidl, __in_opt HANDLE hToken, __in DWORD dwFlags, __out LPWSTR pszPath);
#define CSIDL_APPDATA		0x001a	// <user name>\Application Data
//#include "commctrl.h"
#include "..\relativa/Aerotri_defs_internal.h"
#include <ATcrt/ATmem.h>
#include <ATcrt/ATpaths.h>
#include <ATcrt/ATfiles.h>
#include <ATcrt/ATmemstr.h>
#include <ATcrt\ATstring.h>
#include <ATcrt\ATfileinput.h>
#include <ATcrt\ATfileoutput.h>
#include "..\Win32GUI\GDIWin32_defs.h"
#define IMP_EXP __declspec(dllimport)
#include "..\Win32GUI\BasicPiecesW.h"
#include "..\relativa/Clasesgenericas.h"
#include "codigosmensajesMaster.h"
#include "Master_module.h"

PLIST plist;
//#define MasterNew_add(p,type,n,sample) aj_malloc_add(p,type,n); {type *ptr=p; for(cint __i=n;i--;*ptr++=sample);}
#define MasterNew_add(p,type,n,sample) aj_malloc_add(p,type,n); \
	{type *ptr=p; for(cint _i_=n;_i_--;ptr++) memcpy(ptr,&sample,usizeof(type));}		//The compiler is too clever, or too stupid,
#define MasterNewPlain_add(p,type,n) {type _p_; MasterNew_add(p,type,n,_p_);}		//*p=sample or *p=type() does not copy
#define MasterNew_one(p,type,sample) aj_malloc_add(p,type,1); memcpy(p,&sample,usizeof(type));		//the vft pointer
//#define MasterNewPlain_one(p,type) aj_malloc_add(p,type,1); *p=type()		//memcpy need not cost any penalty, for any intelligent compiler
#define MasterNewPlain_one(p,type) {type _p_; MasterNew_one(p,type,_p_);}		//may replace a call to that function featuring a compile-time
																										//constant third-parameter, with copying code if it considers it better

#include "textos_master.h"
#include "Master_Clases.h"
using namespace System;
using namespace System::Windows::Forms;
using namespace System::Drawing;

static ATOM appwclass;
static HWND app_hwnd;
char16_t* exepath;
char16_t appdata[MAX_PATH+40];
HICON MasterIcon;
u8int notros;
struct{
	InfoComienzo* comie;
	Modulo* modulos;
	PerThreadData* threaddata;
	HICON* Images32;
	HICON* Images16;
	char16_t* (*nombres)[3];
	char16_t* (*tooltips)[3];
} Tabs;
u8int idioma;
uint CurrentApplication;	//1+index
bool cerrando;
//HWND owneds[6];	//Windows owned by Master. When an application is shown ownership must
						//be transfered to the app. window. It would be easier if windows could be made
						//application-topmost.
						//A null value marks the end.

ref class AcercadeMaster;
ref class Administrador;
ref class FormMaster;
ref class MC{
	public:
		static System::String^ ManualPath=nullptr;
		static ControlesAt::MessageBoxAT^ MessageBox=nullptr;
		static FormMaster^ MasterM=nullptr;
		static Administrador^ Visor1=nullptr;
		static AcercadeMaster^ Acercade1=nullptr;
};
#include "Funciones_Master.h"
void etiquetas(u8int _idioma);
#include "AcercadeMaster.h"
#include "Administrador.h"
#include "FormMaster.h"
#include "Comienzo.h"
#include "AppController.h"

int __stdcall wWinMain(HINSTANCE hInstance, HINSTANCE _unused(hPrevInstance), wchar_t *lpCmdLine, int _unused(nCmdShow)){
	System::Threading::Thread::CurrentThread->ApartmentState=System::Threading::ApartmentState::MTA;
	plist=get_new_plist();
	if(plist==PLIST_OUT_OF_MEM) return 1;
	MSG msg;

	/*INITCOMMONCONTROLSEX ccontrol_toload;
	ccontrol_toload.dwSize=sizeof(INITCOMMONCONTROLSEX);
	ccontrol_toload.dwICC=ICC_STANDARD_CLASSES | ICC_TREEVIEW_CLASSES;
	InitCommonControlsEx(&ccontrol_toload);*/

	Application::SetCompatibleTextRenderingDefault(false);
	Application::EnableVisualStyles();
	//Application::VisualStyleState=System::Windows::Forms::VisualStyles::VisualStyleState::NonClientAreaEnabled;

	char16_t** argv=(char16_t**)Basicas::_nogcVarios::split_cmdline(lpCmdLine);
	MC::MessageBox=gcnew ControlesAt::MessageBoxAT();
	MC::MessageBox->Owner=nullptr;
	MC::MessageBox->Caption="Aerotri Manager";

	WNDCLASSEX wcex;
	wcex.cbSize= usizeof(wcex);
	wcex.style=0;
	wcex.lpfnWndProc=&AppControler_WndProc;
	wcex.cbClsExtra=0;
	wcex.cbWndExtra=0;
	wcex.hInstance=hInstance;
	wcex.hIcon=NULL;
	wcex.hIconSm=NULL;
	wcex.hCursor=NULL;
	wcex.lpszMenuName=NULL;
	wcex.hbrBackground=NULL;
	wcex.lpszClassName="AppContrler";
	appwclass=RegisterClassEx(&wcex);
	app_hwnd= CreateWindowEx(0,(LPCSTR)appwclass,NULL, 0, CW_USEDEFAULT, CW_USEDEFAULT, 0,0, HWND_MESSAGE,NULL,hInstance,NULL);
	if(app_hwnd==NULL) return 1;

	MasterIcon=(HICON)LoadImage(hInstance,(LPCTSTR)1,IMAGE_ICON,0,0,LR_DEFAULTSIZE);
	//NULL_set((void**)&owneds[0],6);

	msg.wParam=SetupApp(argv);
	if(msg.wParam) goto salida;
	CreateFormMaster(notros);
	etiquetas(idioma);
	StartupThreads();
	MC::MasterM->Show();
	if(notros && MC::MasterM->OtherButtons[0]->Enabled) button_click(1);
	else MC::MasterM->FormMaster_SizeChanged(nullptr,System::EventArgs::Empty);

	while(GetMessage(&msg,NULL,0,0)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
salida:
	free_plist(plist);
	delete[] argv;
	return (int)msg.wParam;
}
