//Compile with /J
#pragma warning(disable:4265 4710)
#pragma warning(once:4339)
#using <System.dll>
#using <System.Drawing.dll>
#using <System.Windows.Forms.dll>
#include <ATcrt/ATsystem.h>
#include <ATcrt/ATstring.h>
#define _WIN32_WINNT 0x0501
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

using namespace System::Reflection;
using namespace System::Security::Permissions;
[assembly:AssemblyTitleAttribute("SubordinadaForms")];
[assembly:AssemblyDescriptionAttribute("")];
[assembly:AssemblyCompanyAttribute("ProyectoAerotri")];
[assembly:AssemblyProductAttribute("AerotriManager")];
// Version: Major.Minor.Build.Revision
[assembly:AssemblyVersionAttribute("0.5")];
[assembly:System::CLSCompliantAttribute(true)];	//Generates a warning if I am using something not CLS compliant
//[assembly:SecurityPermission(SecurityAction::RequestMinimum, UnmanagedCode=true)];

#include "..\relativa\Aerotri_defs_internal.h"

#ifndef _WIN64
	#using "..\output\Win-x86\Globales.dll"
	#using "..\output\Win-x86\ControlesAt.dll"
	#using "..\output\Win-x86\PanelesSub.dll"
	#using "..\output\Win-x86\Basicas.dll"
#else
	#using "..\output\Win-amd64\Globales.dll"
	#using "..\output\Win-amd64\ControlesAt.dll"
	#using "..\output\Win-amd64\PanelesSub.dll"
	#using "..\output\Win-amd64\Basicas.dll"
#endif

#include "codigosmensajesMaster.h"
#include "Master_module.h"
#include "FormSubordinado.h"

using namespace System;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

extern "C" __declspec(dllexport) IVentanaModule* __cdecl CreateVentana(const InfoComienzo *infocomie, InfoRetrived *inforet, IEnlace** enlaces){
	System::Reflection::Assembly^ module;
	FormSub::wVentanaSubordinada* ventana;
	Type^ tipoPanel;
	char16_t* noarg=NULL;
	char16_t** argv;

	module=nullptr;
	ventana=NULL;
	char16_t modulename[MAX_PATH];
	strbuild16(modulename,infocomie->paths.base_dir,infocomie->paths.name,u".dll",NULL);
	try{module=Assembly::LoadFrom(gcnew String((wchar_t*)modulename));}
	catch(Exception^){module=nullptr;}
	if(module==nullptr) return NULL;
	inforet->needfree_flags=INFORET_FREE_Version;
	System::Version^ version=module->GetName()->Version;
	String^ Sversion= version->Major.ToString() + "." + version->Minor.ToString() + "." + version->Build.ToString();
	inforet->version=new char16_t[Sversion->Length+1];
	if(inforet->version==NULL) return NULL;
	IntPtr P_version=Marshal::StringToHGlobalUni(Sversion);
	{char16_t *ptr=inforet->version,
	*ptrb=(char16_t*)P_version.ToPointer();
	whilenz(*ptr++=*ptrb++);}
	Marshal::FreeHGlobal(P_version);

	if(infocomie->cmdline==NULL) argv=&noarg;
	else argv=(char16_t**)Basicas::_nogcVarios::split_cmdline((wchar_t*)infocomie->cmdline);
	Type^ T=module->GetType(String::Concat(gcnew String((wchar_t*)infocomie->paths.internal_name),".PrincipalSubordinadoInfo"));
	tipoPanel=static_cast<Type^>(T->GetMethod("getTypePanel")->Invoke(nullptr,nullptr));

	ventana=new FormSub::wVentanaSubordinada();
	ventana->wV(tipoPanel,&infocomie->yokeddata,argv,enlaces);
	if(argv!=&noarg) delete[] argv;
	return ventana;
}
extern "C" __declspec(dllexport) int MessageLoop(IVentanaModule *_unused(ventana)){
	Application::Run();
	return 0;
}

extern "C" __declspec(dllexport) char16_t* get_enlace_nombre(IEnlace* enlace){
	return enlace->name;
}
extern "C" __declspec(dllexport) void* get_enlace_hwnd(IEnlace* enlace){
	IVentanaModule *v=enlace->get_ventana();
	if(v==NULL) return NULL;
	return v->get_hwnd();
}
extern "C" __declspec(dllexport) unsigned __int64 get_enlace_Panel(void* _enlace){
	IEnlace *enlace=(IEnlace*)_enlace;
	FormSub::wVentanaSubordinada *v=dynamic_cast<FormSub::wVentanaSubordinada*>(enlace->get_ventana());
		if(v==NULL) return ZeroPtr;
	FormSub::FormSubAerotri^ ppal=v->get_ManagedVentana();
		if(ppal==nullptr) return ZeroPtr;
	GCHandle gch= GCHandle::Alloc(ppal->Panel1,GCHandleType::Weak);
	return (uintptr_t)GCHandle::ToIntPtr(gch).ToPointer();
}
