//Some useful vectors of levels
//0.2	0.4		0.6		0.8		1.0		1.2		1.4		1.6		1.8		2.0		2.19	2.36	2.52	2.67	2.81	2.95	3.08	3.2

u8int numeroresumen(float aux){
	if(aux<0) aux=-aux;
	if(aux<1.0F) return 0;
	if(aux<1.8F){
		if(aux<1.5F) return 1;
		return 2;
	}
	if(aux<2.5F){
		if(aux<2.0F) return 3;
		return 4;
	}
	if(aux<4.0F){
		if(aux<3.2F) return 5;
		return 6;
	}
	return 7;
}

sinline u8int numero(float aux, const float* limites){
	u8int i;
	if(aux<0) aux=-aux;
	for(i=0;isfinite(limites[i]) && aux>=limites[i];i++);	//Changed. Now tests isfinite so that no longer
	return i;								//relies on a value infty at the end. Thereby > can be changed back to >=
}

void fdist_res(uint* dist,float* L,uint n,u8int (*func)(float)){
	u8int kk=func(FLT_MAX)+1;
	zeroset_uint(dist,kk);
	dontimes(n<<1,L++) dist[func(*L)]++;
}
/*void dist_res_apy(uint* dist,float* L,uint n,u8int (*func)(float),PuntoM* puntosA,bint* existen_A){
	u8int kk=func(FLT_MAX)+1;
	zeroset_uint(dist,kk);
	dontimes(n,(existen_A++,puntosA++)){
		if(!*existen_A){L+=3; continue;}
		u8int k=puntosA->bbb;
		if(k&1)	dist[func(*L)]++;	L++;
		if(k&2)	dist[func(*L)]++;	L++;
		if(k&4)	dist[func(*L)]++;	L++;
	}
}
void dist_res_gps(uint* dist,float* L,uint n,u8int (*func)(float),PuntoGPSINS* gpss){
	u8int kk=func(FLT_MAX)+1;
	zeroset_uint(dist,kk);
	dontimes(n,gpss++){
		if(!gpss->bg){L+=3; continue;}
		dist[func(*L++)]++;
		dist[func(*L++)]++;
		dist[func(*L++)]++;
	}
}
void dist_res_ins(uint* dist,float* L,uint n,u8int (*func)(float),PuntoGPSINS* gpss,uint* ins_a_gps){
	u8int kk=func(FLT_MAX)+1;
	zeroset_uint(dist,kk);
	dontimes(n,ins_a_gps++){
		if(!gpss[*ins_a_gps].bi){L+=3; continue;}
		dist[func(*L++)]++;
		dist[func(*L++)]++;
		dist[func(*L++)]++;
	}
}*/

void dist_res(uint* dist,float* L,uint n, const float* limites){
	{const float *ptr=limites; while(isfinite(*ptr)) ptr++;
	zeroset_uint(dist,(pdif)(ptr-limites)+1);}
	dontimes(n<<1,L++) dist[numero(*L,limites)]++;
}
void dist_res_apy(uint* dist,float* L,uint n, const float* limites,PuntoM* puntosA,bint* existen_A){
	{const float *ptr=limites; while(isfinite(*ptr)) ptr++;
	zeroset_uint(dist,(pdif)(ptr-limites)+1);}
	dontimes(n,(existen_A++,puntosA++)){
		if(!*existen_A){L+=3; continue;}
		u8int k=puntosA->bbb;
		if(k&1) dist[numero(*L,limites)]++;		L++;
		if(k&2) dist[numero(*L,limites)]++;		L++;
		if(k&4) dist[numero(*L,limites)]++;	L++;
	}
}
void dist_res_gps(uint* dist,float* L,uint n, const float* limites,PuntoGPSINS* gpss){
	{const float *ptr=limites; while(isfinite(*ptr)) ptr++;
	zeroset_uint(dist,(pdif)(ptr-limites)+1);}
	dontimes(n,gpss++){
		if(!gpss->bg){L+=3; continue;}
		dist[numero(*L++,limites)]++;
		dist[numero(*L++,limites)]++;
		dist[numero(*L++,limites)]++;
	}
}
void dist_res_ins(uint* dist,float* L,uint n,const float* limites,PuntoGPSINS* gpss,uint* ins_a_gps){
	{const float *ptr=limites; while(isfinite(*ptr)) ptr++;
	zeroset_uint(dist,(pdif)(ptr-limites)+1);}
	dontimes(n,ins_a_gps++){
		if(!gpss[*ins_a_gps].bi){L+=3; continue;}
		dist[numero(*L++,limites)]++;
		dist[numero(*L++,limites)]++;
		dist[numero(*L++,limites)]++;
	}
}
