﻿#pragma once

//Escribe fout->prec cifras significativas
void fPrecGirocg(Bufferto8 *fout, float fl, const char8_t *cg, const char8_t* unig){
	s8int prec=(s8int)fout->prec.signi;
	s8int d;
	bint added, bneg=false;

	if(fl==0) d=0;
	else d=log10n(fl);
	if(d-prec>=4 || -d>3){
		bint relative=isbuf_relative(fout);
		s8int preca=fout->prec.absol;
		setbuf_absolutep(fout,prec-1);
		fl/=pow10f(d);
		towrite8_float(fout,fl);
		fout->prec.absol=preca;
		toput_char(fout,'E');
		if(d<0){toput_char(fout,'-'); d=-d;}
		else toput_char(fout,'+');
		if(d<10) toput_char(fout,'0');
		towrite8_uint(fout,d);
		if(unig!=NULL){
			toput_char(fout,' ');
			towrite8_string(fout,unig);
		}
		if(relative) setbuf_relative(fout);
		return;
	}
	
	if(fl<0){fl=-fl; bneg=true;}
	d=prec-d-1;
	if(d<=0){
		uint n=(uint)(fl+0.5);
		if(bneg) toput_char(fout,'-');
		towrite8_uint(fout,n);
		towrite8_string(fout,cg);
		return;
	}

	uint n, n2;
	n=(uint)fl;
	if(d==1 || fl-n>=.9F){
		fl+=0.5F*pow10f(-d);
		n=(uint)fl;
		added=true;
	}else added=false;
	fl-=n;
	fl*=pow10f(d); if(!added) fl+=0.5F;
	n2=(uint)fl;
	if(isbuf_limpio(fout)){
		while(n2!=0 && n2%10==0) n2/=10, d--;
		if(n2==0) d=0;
	}
	if(bneg) toput_char(fout,'-');
	if(d==0){
		if(bneg && n!=0) toput_char(fout,'-');
		towrite8_uint(fout,n); towrite8_string(fout,cg);
	}else{
		if(bneg) toput_char(fout,'-');
		towrite8_uint(fout,n);
		towrite8_string(fout,cg);
		fout->fillchar='0';
		towrite8_aligned_uint(fout,n2,d);
		fout->fillchar=' ';
	}
}

void fGradoSex(Bufferto8* finf, double fl, char16_t c, char16_t s){
	if(fl==0){toput_char(finf,'0'); return;}
	s8int prec;
	float logd;
	s8int d;
	uint n;
	bint printed;
	char8_t waiting=0;

	if(fl<0){toput_char(finf,'-'); fl=-fl;}
	if(isbuf_absolute(finf)) logd=-(float)finf->prec.absol;
	else logd=(float)log10(fl)-(float)finf->prec.signi+1;

	if(logd>=0){towrite8_uint(finf,(uint)(fl+0.5F)); towrite_utf8char(finf,u'°'); return;}
	if(logd>-1.7781513F){prec=2; fl+=0.00833333F;}
	elif(logd>-3.5563036F){prec=4; fl+=1.388888e-4F;}
	else{
		prec=5;
		d=(s8int)(int)floorf(logd+3.5563036F);
		fl+=1.388888e-4F * pow10f(d);
		d=-d;
	}

	if(isbuf_absolute(finf)) printed=true;	//start printing
	else printed=false;
	n=(uint)fl;
	if(printed || n>0){
		towrite8_uint(finf,n); towrite_utf8char(finf,u'°');
		fl-=n;
		printed=true;
	}
	fl*=60;
	n=(uint)fl;
	if(prec<=2){
		if(n!=0 || !isbuf_limpio(finf)){
			if(printed && n<10) toput_char(finf,'0');
			towrite8_uint(finf,n); towrite_utf8char(finf,c);
		}
		return;
	}
	if(n>0 || (printed && !isbuf_limpio(finf))){
		if(printed && n<10) toput_char(finf,'0');
		towrite8_uint(finf,n); towrite_utf8char(finf,c);
		fl-=n;
		printed=true;
	}elif(printed){	//hence limpio
		waiting=1;
	}
	fl*=60;
	n=(uint)fl;
	if(prec<=4){
		if(waiting && n!=0){towrite8_string(finf,"00"); towrite_utf8char(finf,c);}
		if(n!=0 || !isbuf_limpio(finf)){
			if(printed && n<10) toput_char(finf,'0');
			towrite8_uint(finf,n); toput_utf8char(finf,s);
		}
		return;
	}
	if(n>0 || (printed && !isbuf_limpio(finf))){
		if(waiting && n!=0){towrite8_string(finf,"00"); towrite_utf8char(finf,c); waiting=0;}
		if(printed && n<10) toput_char(finf,'0');
		towrite8_uint(finf,n); towrite_utf8char(finf,s);
		fl-=n;
	}elif(printed){	//hence limpio
		if(!waiting) waiting=2;
	}else{
		toput_char(finf,'0'); towrite_utf8char(finf,s);
	}

	n=(uint)(fl*pow10f(d));
	if(isbuf_limpio(finf)){
		while(n!=0 && n%10==0) n/=10, d--;
		if(n==0) d=0;
	}
	if(d>0){
		if(waiting){
			if(waiting==1){towrite8_string(finf,"00"); towrite_utf8char(finf,c);}
			towrite8_string(finf,"00"); towrite_utf8char(finf,s);
		}
		finf->fillchar='0';
		towrite8_aligned_uint(finf,n,d);
		finf->fillchar=' ';
	}
}

sinline void fGradoSexU8(Bufferto8 *finf, double fl){
	fGradoSex(finf, fl,u'’',u'”');
}
sinline void fGradoSexT1(Bufferto8 *finf, double fl){
	fGradoSex(finf, fl,u'\'',u'\021');
}

//Escribe incondicionalmente en modo relative
void fPrecGiro(Bufferto8 *fout,float fl, const char8_t *cg, const char8_t* unig, void (*equiv)(Bufferto8*,double,char16_t,char16_t)){
	if(cg!=NULL) fPrecGirocg(fout,fl,cg,unig);
	else towrite8(fout,'f',fl,' ', 's',unig);
	if(equiv!=NULL){
		towrite8_string(fout," = ");
		equiv(fout,fl,u'’',u'”');
	}
}
