﻿#pragma once
/*Compartidos entre los módulos que manejan los elementos gráficos
y los que manejan la configuración.
*/
#include "grafico_memoria_public.h"
#include "Clases_grafico_independiente.h"
#define Gra_NODATA AT_NODATA

typedef struct{
	PuntoXYZ_double P;
	double Σ[3][3];	//They are double for the sake of operating with them, but they are "logic" floats, both for precision and range.
} ConvexEllipsoide; //Obviously, all ellipsoides are convex, but this name helps remember the structure's purpose

typedef struct{
	uint Tipo;	//tipo y subtipo
	uint tamaño;
	uint pos_info;
	uint Clase;	//El segundo bit más alto es el de simple precisión. En memoria siempre se guarda double, pero sigue siendo
					//necesario para distinguir unidades de X,Y/unidades de Z y para saber cómo se debe guardar en el fichero.
	uint nombre;
	float escala; //Escala con la que está calculado bound. Para los elementos en los que no es de aplicación siempre valdrá 1.
	ConvexEllipsoide bound;  //Para poder calcular de manera rápida unos máx y mín para cualquier rotación de la vista
} ElemenCabecera;

typedef struct{
	ElemenCabecera H;
	uint VLA_partegrafica;	//primer 4-byte de la parte gráfica
} GraElementoGenerico;
