#include <ATcrt/ATsystem.h>
#include <ATcrt/ATmem.h>
#include "ClasesGPS.h"
#include <ATsistemas/ClaseSistema.h>
#include "clases_infobinario.h"
#ifdef __cplusplus
extern "C"{
#endif
//Devuelve 0 si todo bien, AT_NOMEM en su caso,
//y el error de ATFILEO en caso de error
int escribe_ficherobnf(const char16_t* ficherobnf, const FicheroBnf *datos);
int leeficherobnf(char16_t* ficherobnf, FicheroBnf *datos);

void free_filas(void* filas);
//en estas funciones las variables dec, indican cómo se escriben los residuos:
//  <=0:Número de decimales fijo igual a -dec
//  >0: Número de cifras significativas
//  Si decins es -127 el número de decimales fijo lo decide la función según el valor de fccpi (las unidades de los valores angulares)
int rellena_res_porfotos(BnfTabla_ResporFoto *tabla, s8int dec, bint llena_nombres, uint ncp,const uint* orden_cp, const uint* p_cp_acum,const int4* mafp,
											const CentroProy* centros,const PuntoM* puntosM, const float* L,const float* L_norm,const uint* pm_ppios, const PuntoM* puntosA);

int rellena_res_porpuntos(BnfTabla_ResporPunto *tabla, s8int dec, bint llena_nombres, uint npm,const uint* orden_pm, const uint* pm_ppios,const int2* p_en_cp, const int4* mafp,
											uint ntot, const CentroProy* centros,const PuntoM* puntosM, const float* L,const float* L_norm, const PuntoM* puntosA);

int rellena_res_apoyo(BnfTabla_ResApoyo *tabla, s8int dec, const PuntoM* puntosA, uint npy, bint fijas,const uint* pA_a_pM, const float* Lp,const float* Lp_norm,
											const PuntoM* puntosC,uint npc,const uint* pC_a_pM, const float* Lpc, const float* Lpc_norm);

int rellena_res_gpsins(BnfTabla_ResGPS* tabla, s8int decgps, s8int decins, const GrupoGPSINS* grupos, uint ngrupos, const uint* grupos_acum, const PuntoGPSINS* gpss,
											const float* Lgps, const float* Lgps_norm, const float* Lins, const float* Lins_norm, float fccpi);
#ifdef __cplusplus
}
#endif
