﻿char8_t* strstr8(iconst char8_t* cp,const char8_t* str2){
	while(*cp){
		const char8_t *s1, *s2;
		s1=cp++; s2=str2;
		while(*s1==*s2 && *s2) s1++, s2++;
		if(!*s2){cp--; break;}
	}
	return (ICONST char8_t*)cp;
}
char16_t* strstr16(iconst char16_t * cp,const char16_t * str2){
	while(*cp){
		const char16_t *s1, *s2;
		s1=cp++; s2=str2;
		while(*s1==*s2 && *s2) s1++, s2++;
		if(!*s2){cp--; break;}
	}
	return (ICONST char16_t*)cp;
}

/*There must be a '\n' before the first appearance of "marca", even if it is back from pc
So if pc is at the beginning of a string we need pc[-1]='\n'. (so pc would point char nº 1 of the string)
The returned value points to the beginning of the next word, to the '\n' at the end of line if
there is no next word or the '\0' of the end of the end of the file if the word marca does not appear*/
char8_t* get_codigo8(iconst char8_t* pc,const char8_t* marca){
	const char8_t* cc;
	cc=marca; while(*cc) cc++;
	const uint nw=(pdif)(cc-marca);
bucle:
	pc=strstr8(pc,marca);
	if(*pc=='\0') return (char8_t*)pc;
	cc=pc;
	pc+=nw;
	if(*pc!=' ' && *pc!='\t' && *pc!='\n') goto bucle;
	while(*(--cc)==' ' || *cc=='\t');
	if(*cc!='\n') goto bucle;

	while(*pc==' ' || *pc=='\t') pc++;
	return (ICONST char8_t*)pc;
}
char16_t* get_codigo16(iconst char16_t* pc,const char16_t* marca){
	const char16_t* cc;
	cc=marca; while(*cc) cc++;
	const uint nw=(pdif)(cc-marca);
bucle:
	pc=strstr16(pc,marca);
	if(*pc=='\0') return (char16_t*)pc;
	cc=pc;
	pc+=nw;
	if(*pc!=' ' && *pc!='\t' && *pc!='\n') goto bucle;
	while(*(--cc)==' ' || *cc=='\t');
	if(*cc!='\n') goto bucle;

	while(*pc==' ' || *pc=='\t') pc++;
	return (ICONST char16_t*)pc;
}

char8_t* prepare_key8(Bufferti8 *buf, const char8_t c_char){
	char8_t *ptr;
	char8_t *s;

	s=buf->pc; do s++; while(*s!='=' && *s!='\n' && *s!=c_char); if(*s!='=') return NULL;
	*s=' ';

	ptr=buf->pc;
	prepare_string(*buf); //buf->savedchar no será nunca '\n'
	buf->pc=buf->next+1; //Ya que buf->savedchar!='\n'
	advanceinline(*buf); //The code for Advance_inline is the same
	return ptr;
}

char16_t* prepare_key16(Bufferti16 *buf, const char16_t c_char){
	char16_t *ptr;
	char16_t *s;

	s=buf->pc; do s++; while(*s!='=' && *s!='\n' && *s!=c_char); if(*s!='=') return NULL;
	*s=' ';

	ptr=buf->pc;
	prepare_string(*buf); //buf->savedchar no será nunca '\n'
	buf->pc=buf->next+1; //Ya que buf->savedchar!='\n'
	advanceinline(*buf); //The code for Advance_inline is the same
	return ptr;
}

char8_t* codigo_advance(iconst char8_t* pc,const char8_t* marca, const int nw){
	const char8_t* cc;
bucle:
	pc=strstr8(pc,marca);
	if(*pc=='\0') return (ICONST char8_t*)pc;
	cc=pc;
	pc+=nw;
	if(*pc!=' ' && *pc!='\t' && *pc!='\n') goto bucle;
	while(*(--cc)==' ' || *cc=='\t');
	if(*cc=='\n'){str_no_stn(pc); return (ICONST char8_t*)pc;}
	goto bucle;
}

//Busca el primer carácter de " =\t\n\0"
char8_t* seek_finkey(iconst char8_t *s){
	while(*s){
		if(*s<=' ' && (*s==' ' || *s=='\t' || *s=='\n')) break;
		if(*s=='=') break;
		s++;
	}
	return (ICONST char8_t*)s;
}

void key_advance(Bufferti8 *buffer){/*pone 0 al final de la clave y avanza hasta el primer no-espacio después del =*/\
	if(*buffer->pc=='\0') return;
	buffer->next=seek_finkey(buffer->pc);
	buffer->savedchar=*buffer->next;
	*buffer->next++='\0';
	if(buffer->savedchar!='='){
		buffer->pc=strseek8(buffer->next,'=');
		if(*buffer->pc=='\0'){
			*(buffer->next-1)='\n';
			*buffer->next='\0';
			buffer->pc=buffer->next;
			return;
		}
		buffer->next=buffer->pc+1;
	}
	buffer->pc=buffer->next;
	str_no_stn(buffer->pc);
}
